// errortoken.hh
// error token class
// Kevin Puckett Albrecht
// Rev 3
// 21 March 2000 - 27 June 2000

#ifndef ERRORTOKEN_HH
#define ERRORTOKEN_HH

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //
#include <string.h>

// Local //
#include "k_string.hh"
#include "token.hh"
#include "inbuffer.hh"
#include "error.hh"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

class ErrorToken : public Token
{
  public:
    ErrorToken () {code = codeDummy;}

    virtual void Get ();
    virtual bool IsDelimiter () const {return false;}
};

//// Get ////
void ErrorToken::Get ()
{
  buffer[0] = gpBuffer->Get ();
  buffer[1] = '\0';

  gpBuffer->Seek ();
  gpErrorS->Show (EFF_IGNORE, ES_UNDEFINED_TOKEN, buffer);
}

#endif