// specialtoken.hh
// special token class
// Kevin Puckett Albrecht
// Rev 5
// 21 March 2000 - 4 May 2001

#ifndef SPECIALTOKEN_HH
#define SPECIALTOKEN_HH

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //
#include <string.h>

// Local //
#include "k_string.hh"
#include "token.hh"
#include "common.hh"
#include "inbuffer.hh"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

class SpecialToken : public Token
{
  public:
    virtual void Get ();
    virtual bool IsDelimiter () const {return true;}
};

void SpecialToken::Get ()
{
  char ch = gpBuffer->Get ();
  int pos = 0;

  buffer[pos++] = ch;

  switch (ch) {
    case '@': code = codeANDSIGN;      gpBuffer->Seek (); break;
    case '?': code = codeQUESTIONMARK; gpBuffer->Seek (); break;
    case '*': code = codeTIMES;        gpBuffer->Seek (); break;
    case '&': code = codeAPPEND;       gpBuffer->Seek (); break;
    case '(': code = codeLEFTPAREN;    gpBuffer->Seek (); break;
    case ')': code = codeRIGHTPAREN;   gpBuffer->Seek (); break;
    case '-': code = codeMINUS;        gpBuffer->Seek (); break;
    case '+': code = codePLUS;         gpBuffer->Seek (); break;
    case '=': code = codeEQUAL;        gpBuffer->Seek (); break;
    case ',': code = codeCOMMA;        gpBuffer->Seek (); break;
    case '/': code = codeDIVIDE;       gpBuffer->Seek (); break;
    case ':': code = codeCOLON;        gpBuffer->Seek (); break;
    case '.': code = codeDOT;          gpBuffer->Seek (); break;
    case '<': // < or <= or <> or <<
              gpBuffer->Seek ();
              ch = gpBuffer->Get ();
              if (ch == '=')
              {
                buffer[pos++] = '=';
                code = codeLTEQUAL;
                gpBuffer->Seek ();
              }
              else if (ch == '>')
              {
                buffer[pos++] = '>';
                code = codeNOTEQUAL;
                gpBuffer->Seek ();
              }
              else if (ch == '<')
              {
                buffer[pos++] = '>';
                code = codeCONVERT;
                gpBuffer->Seek ();
              }
              else
              {
                code = codeLT;
              }
              break;

    case '>': // > or >=
              gpBuffer->Seek ();
              ch = gpBuffer->Get ();
              if (ch == '=')
              {
                buffer[pos++] = '=';
                code = codeGTEQUAL;
                gpBuffer->Seek ();
              }
              else
              {
                code = codeGT;
              }
              break;
    default: // error
             code = codeDummy;
             gpBuffer->Seek ();
             gpErrorS->Show (EFF_IGNORE, ES_UNDEFINED_TOKEN);
             break;
  }
  buffer[pos] = '\0';
}

#endif
