// value.hh
// type declarations and Value class
// Kevin Puckett Albrecht
// Rev 14
// 17 April 2000 - 4 May 2001
//
// must define: GLOBAL_MANTISSA_SIZE

#ifndef VALUE_HH
#define VALUE_HH

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //
#include "k_string.hh"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

enum Type
{
  tDummy, tMarker, tValue,
  tRoutine /*not implemented*/
};

char *gvsTypeStrings[] =
{
  "null", "marker", "value",
  "routine" /*not implemented*/
};

class Value
{
  public:
    static char *String (bool ab);
    static char *String (int an);
    static char *String (float af);
    static char *String (char ac);

    static bool Bool (char *aS);
    static bool BoolD (char *aS);
    static int Int (char *aS);
    static int IntD (char *aS);
    static float Float (char *aS);
    static float FloatD (char *aS);
};

char *Value::String (bool ab)
{
  if (ab) return "1";
  else    return "0";
}

char *Value::String (int an)
{
  return k_int (an);
}

char *Value::String (float af)
{
  return k_float (af, GLOBAL_MANTISSA_SIZE);
}

char *Value::String (char ac)
{
  char *s = new char[2];
  s[0] = ac;
  s[1] = '\0';
  return s;
}

bool Value::Bool (char *aS)
{
  if (aS == NULL) return false;
  return (k_same (aS, "false") || k_same (aS, "0") || k_same (aS, "0.") ||
          k_same (aS, "0.0") || k_same (aS, "0.00") || k_same (aS, "0.000") ||
          k_same (aS, "0.0000") || k_same (aS, "0.00000")
         ) ? false : true;;
}

bool Value::BoolD (char *aS)
{
  bool temp = Bool (aS);
  k_del (aS);
  return temp;
}

int Value::Int (char *aS)
{
  if (aS == NULL) return false;
  return (atoi (aS));
}

int Value::IntD (char *aS)
{
  int temp = Int (aS);
  k_del (aS);
  return temp;
}

float Value::Float (char *aS)
{
  if (aS == NULL) return false;
  return ((float) atof (aS));
}

float Value::FloatD (char *aS)
{
  float temp = Float (aS);
  k_del (aS);
  return temp;
}

#endif